//	+---------------------------+
//	|	blocklandsaves.com		|
//	|	Web Saves				|
//	+---------------------------+
//	|	client.cs				|
//	+---------------------------+
//	|	Version: 1.0			|
//	|	Date: Jan.22.2014		|
//	|	Author: Zapk | 12270	|
//	+---------------------------+

$WebSaves::Client::Version = "1.0";

if(!$WebSaves::KeybindLoaded)
{
	$remapDivision[$remapCount] = "Web Saves";
	$remapName[$remapCount] = "Open Browser";
	$remapCmd[$remapCount] = "WebSavesOpen";
	$remapCount++;
	$WebSaves::KeybindLoaded = true;
}

if(!$WebSaves::ProfilesLoaded)
{
	exec("./profiles.cs");
}

if(!isObject(WebSaves_Gui))
{
	exec("./WebSaves.gui");
}

function WebSavesOpen()
{
	canvas.pushDialog(WebSaves_Gui);
	WebSaves_FetchMemberList();
	WebSaves_SaveBitmap.setBitmap("Add-Ons/System_WebSaves/images/no-icon.png");
	WebSaves_SaveInfo.setValue("");
	//schedule(800, 0, WebSaves_CheckForUpdates, true);
}

function WebSaves_CreateListItem(%title,%type,%id)
{
	if(%title $= "")
	{
		%title = "Title Error";
	}
	%y = (WebSaves_List.getCount() * 48) + 1;
	%this = new GuiBitmapCtrl()
	{
		horizSizing = "right";
		vertSizing = "bottom";
		position = "1" SPC %y;
		extent = "341 45";
		bitmap = "./images/item";
		WebSaves_ID = WebSaves_List.getCount() + 1;
	
		new GuiMLTextCtrl()
		{
			profile = "WebSaves_ContentBorderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 4";
			extent = "250 36";
			text = "<font:arial:18><color:323232>" @ %title;
			maxLength = "255";
			autoResize = "0";
			selectable = "0";
		};
		new GuiBitmapButtonCtrl()
		{
			horizSizing = "right";
			vertSizing = "center";
			position = "306 14";
			extent = "16 16";
			text = " ";
			command = (%type $= "download" ? "WebSaves_DownloadToServer(\"" @ %id @ "\");" : "") @ (%type $= "user" ? "WebSaves_ViewMemberFiles(\"" @ %id @ "\");" : "");
			bitmap = (%type $= "download" ? "Add-Ons/System_WebSaves/images/download" : "") @ (%type $= "user" ? "Add-Ons/System_WebSaves/images/book_next" : "");
		};
		new GuiBitmapButtonCtrl()
		{
			horizSizing = "right";
			vertSizing = "center";
			position = "286 14";
			extent = "16 16";
			text = " ";
			command = "WebSaves_ViewFileInfo(\"" @ %id @ "\");";
			visible = (%type $= "download" ? true : false);
			bitmap = "Add-Ons/System_WebSaves/images/info";
		};
	};
	//WebSaves_List.extent = "258" SPC %y + 48;
	WebSaves_List.resize("1", "1", "343", %y + 48);
	WebSaves_List.add(%this);
}

function WebSaves_ClearList()
{
	WebSaves_Scroll.scrollToTop();
	WebSaves_List.deleteAll();
	//WebSaves_List.position = "1 1";
	//WebSaves_List.extent = "258 1";
	WebSaves_List.resize("1", "1", "343", "1");
}

function WebSaves_FetchMemberList()
{
	WebSaves_ClearList();
	WebSaves_Window.setValue("Web Saves - Fetching List");
	if(!isObject(WebSavesTCP))
	{
		new TCPObject(WebSavesTCP);
	}
	
	%this = WebSavesTCP;
	
	%this.type = "users";
	%this.server = "blocklandsaves.com";
	%this.port = 80;
	%this.dir = "/api.php?cmd=users";
	%this.connect(%this.server @ ":" @ %this.port);
}

function WebSaves_CheckForUpdates(%hide)
{
	WebSaves_Window.setValue("Web Saves - Checking for Updates");
	if(!isObject(WebSavesTCP))
	{
		new TCPObject(WebSavesTCP);
	}
	
	%this = WebSavesTCP;
	
	%this.hideUpToDate = %hide;
	%this.type = "updatecheck";
	%this.server = "blocklandsaves.com";
	%this.port = 80;
	%this.dir = "/api.php?cmd=currversion";
	%this.connect(%this.server @ ":" @ %this.port);
}

function WebSaves_ParseVersionData(%hide)
{
	WebSaves_UpdateBitmap.setBitmap("Add-Ons/System_WebSaves/images/information.png");
	WebSaves_UpdateHeader.setValue("Update Info");
	if($WebSaves::UpdateCheck::Array["VERSION NUM"] !$= $WebSaves::Client::Version)
	{
		WebSaves_UpdateWindow.setVisible(true);
		WebSaves_UpdateText.setValue("A new version (" @ $WebSaves::UpdateCheck::Array["VERSION NUM"] @ ") was released on " @ $WebSaves::UpdateCheck::Array["RELEASED"] @ ". You may want to consider updating.");
	}
	else if(!%hide)
	{
		WebSaves_UpdateWindow.setVisible(true);
		WebSaves_UpdateText.setValue("You have the latest version of Web Saves.");
	}
}

function WebSaves_ViewMemberFiles(%username)
{
	WebSaves_ClearList();
	WebSaves_Window.setValue("Web Saves - Fetching List");
	if(!isObject(WebSavesTCP))
	{
		new TCPObject(WebSavesTCP);
	}
	
	%this = WebSavesTCP;
	
	%this.type = "list";
	%this.server = "blocklandsaves.com";
	%this.port = 80;
	%this.dir = "/api.php?cmd=list&u=" @ urlEnc(%username);
	%this.connect(%this.server @ ":" @ %this.port);
}

function WebSaves_DownloadToServer(%uni_code)
{
	WebSaves_Window.setValue("Web Saves - Sending to Server...");
	commandToServer('WebSaves_DownloadFile', %uni_code);
	WebSaves_Window.schedule(getRandom(50,300), setValue, "Web Saves");
}

function ClientCmdWebSaves_ClientError(%header, %body)
{
	if(!WebSaves_Gui.isAwake())
	{
		canvas.pushDialog(WebSaves_Gui);
	}
	WebSaves_UpdateWindow.setVisible(true);
	WebSaves_UpdateBitmap.setBitmap("Add-Ons/System_WebSaves/images/server_error.png");
	WebSaves_UpdateHeader.setValue(%header);
	WebSaves_UpdateText.setValue(%body);
}

function WebSaves_ViewFileInfo(%uni_code)
{
	if(!isObject(WebSavesTCP))
	{
		new TCPObject(WebSavesTCP);
	}
	
	%this = WebSavesTCP;
	
	%saveTo = "base/client/WebSaves/temp.png";
		
	if(%uni_code $= "")
	{
		return;
	}
	
	if(isFile(%saveTo))
	{
		fileDelete(%saveTo);
	}
	
	%this.type = "thumb";
	%this.server = "blocklandsaves.com";
	%this.port = 80;
	%this.dir = "/api.php?cmd=thumb&f=" @ %uni_code;
	%this.saveTo = %saveTo;
	%this.length = "";
	%this.connect(%this.server @ ":" @ %this.port);
	
	%string = "<spush><font:impact:20><color:323232>" @ $WebSaves::FileData[%uni_code, "name"] @ "<spop>";
	%string = %string NL "<spush><font:impact:18><color:323232>Description:<spop>" SPC $WebSaves::FileData[%uni_code, "desc"];
	%string = %string NL "<spush><font:impact:18><color:323232>Credits:<spop>" SPC $WebSaves::FileData[%uni_code, "credits"];
	%string = %string NL "<spush><font:impact:18><color:323232>Size:<spop>" SPC $WebSaves::FileData[%uni_code, "size"];
	%string = %string NL "<spush><font:impact:18><color:323232>Date:<spop>" SPC $WebSaves::FileData[%uni_code, "date"];
	%string = %string NL "<spush><font:impact:18><color:323232>Downloads:<spop>" SPC $WebSaves::FileData[%uni_code, "downloads"];
	
	WebSaves_SaveInfo.setValue(%string);
	
	WebSaves_SaveBitmap.setBitmap("Add-Ons/System_WebSaves/images/downloading.png");
}

if(isPackage("WebSavesClient"))
{
	deactivatePackage("WebSavesClient");
}

package WebSavesClient
{
	function canvas::setContent(%this,%content)
	{
		Parent::setContent(%this,%content);
		if(%content $= "WebSaves_Gui" || WebSaves_Gui.isAwake())
		{
			WebSaves_FetchMemberList();
			schedule(500, 0, WebSaves_CheckForUpdates, true);
		}
	}
	
	function WebSavesTCP::onConnected(%this)
	{
		WebSaves_Window.setValue("Web Saves - Connected");
		if(%this.type $= "thumb")
		{
			WebSaves_Window.setValue("Web Saves - Downloading Preview");
		}
		%this.send("GET" SPC %this.dir SPC "HTTP/1.0\r\nHost:" SPC %this.server @ "\r\n\r\n");
	}
	
	function WebSavesTCP::onConnectFailed(%this)
	{
		error("Connection failed.");
		%this.schedule(333, delete);
	}
	
	function WebSavesTCP::onDNSFailed(%this)
	{
		error("DNS lookup failed.");
		%this.schedule(333, delete);
	}
	
	function WebSavesTCP::onLine(%this,%line)
	{
		if(%this.type $= "users")
		{
			if(%line $= "START")
			{
				%this.isFetchingList = true;
				return;
			}
			if(%line $= "END")
			{
				%this.isFetchingList = false;
				return;
			}
			if(%this.isFetchingList && %line !$= "")
			{
				%files = getField(%line, 2);
				%name = getField(%line, 3);
				WebSaves_CreateListItem(%name NL "<font:arial:12>Files:" SPC %files, "user", %name);
			}
			WebSaves_Window.setValue("Web Saves");
			%this.schedule(333, delete);
		}
		
		if(%this.type $= "updatecheck")
		{
			%var = getField(%line, 0);
			%contents = getField(%line, 1);
			
			$WebSaves::UpdateCheck::Array[%var] = %contents;
			
			WebSaves_Window.setValue("Web Saves");
			schedule(333, 0, WebSaves_ParseVersionData, %this.hideUpToDate);
			%this.schedule(333, delete);
		}
		
		else if(%this.type $= "list")
		{
			if(%line $= "START")
			{
				%this.isFetchingList = true;
				return;
			}
			if(%line $= "END")
			{
				%this.isFetchingList = false;
				return;
			}
			if(%this.isFetchingList && %line !$= "")
			{
				%uni_code = getField(%line, 7);
				$WebSaves::FileData[%uni_code, "name"] = strreplace(getField(%line, 0),"\\","");
				$WebSaves::FileData[%uni_code, "desc"] = getField(%line, 1);
				$WebSaves::FileData[%uni_code, "credits"] = getField(%line, 2);
				$WebSaves::FileData[%uni_code, "size"] = getField(%line, 4);
				$WebSaves::FileData[%uni_code, "date"] = getField(%line, 5);
				$WebSaves::FileData[%uni_code, "downloads"] = getField(%line, 6);
				
				WebSaves_CreateListItem($WebSaves::FileData[%uni_code, "name"] NL "<font:arial:12>by" SPC $WebSaves::FileData[%uni_code, "credits"], "download", %uni_code);
			}
			WebSaves_Window.setValue("Web Saves");
			%this.schedule(333, delete);
		}
		
		else if(%this.type $= "thumb")
		{
			if(strPos(%line,"Content-Length:") >= 0)
			{
				%this.length = getWords(%line, 1, 5);
			}
	
			if(%line $= "")
			{
				%this.setBinarySize(%this.length);
			}
			
			if(%line $= "NO THUMBNAIL")
			{
				%this.disconnect();
				WebSaves_SaveBitmap.setBitmap("Add-Ons/System_WebSaves/images/no-icon.png");
				WebSaves_Window.setValue("Web Saves");
				%this.schedule(333, delete);
			}
		}
	}
	
	function WebSavesTCP::onBinChunk(%this,%chunk)
	{
		if(%this.type $= "thumb")
		{
			if(%chunk < %this.length)
			{
				return;
			}
			if(!isWriteableFilename(%this.saveTo))
			{
				error("Cannot write to file.");
			} 
			else 
			{
				%this.saveBufferToFile(%this.saveTo);
			}
		}
	}
	
	function WebSavesTCP::onDisconnect(%this)
	{
		if(%this.type $= "thumb")
		{
			%this.disconnect();
			WebSaves_SaveBitmap.setBitmap("Add-Ons/System_WebSaves/images/no-icon.png");
			if(isFile(%this.saveTo))
			{
				WebSaves_SaveBitmap.setBitmap(%this.saveTo);
			}
			WebSaves_Window.setValue("Web Saves");
			%this.schedule(666, delete);
		}
	}
};
activatePackage("WebSavesClient");