//	+---------------------------+
//	|	blocklandsaves.com		|
//	|	Web Saves				|
//	+---------------------------+
//	|	server.cs				|
//	+---------------------------+
//	|	Version: 1.0			|
//	|	Date: Jan.22.2014		|
//	|	Author: Zapk | 12270	|
//	+---------------------------+

if(isPackage("WebSavesServer"))
{
	deactivatePackage("WebSavesServer");
}

package WebSavesServer
{
	function WebSavesDownloader::onConnected(%this)
	{
		%this.send("GET" SPC %this.dir SPC "HTTP/1.0\r\nHost:" SPC %this.server @ "\r\n\r\n");
	}
	
	function WebSavesDownloader::onConnectFailed(%this)
	{
		error("Connection failed.");
		%this.delete();
	}
	
	function WebSavesDownloader::onDNSFailed(%this)
	{
		error("DNS lookup failed.");
		%this.delete();
	}
	
	function WebSavesDownloader::onLine(%this,%line)
	{
		if(strPos(%line,"Content-Length:") >= 0)
		{
			%this.length = getWords(%line, 1, 5);
		}
		
		if(strPos(%line,"WebSaves-Filename:") >= 0)
		{
			%this.fileName = getWords(%line, 1, 5);
			echo("File name: " @ %this.fileName);
			if(%this.fileName !$= "")
			{
				MessageAll('MsgUploadEnd', "\c6Loading save \c4" @ strreplace(%this.fileName, "\\", "") @ "\c6 from the web.");
			}
			%this.startTime = $Sim::Time;
		}

		if(%line $= "")
		{
			%this.setBinarySize(%this.length);
		}
	}
	
	function WebSavesDownloader::onBinChunk(%this,%chunk)
	{
		if(%chunk < %this.length)
		{
			return;
		}
		if(!isWriteableFilename(%this.saveTo))
		{
			error("Cannot write to file.");
		} 
		else 
		{
			%this.saveBufferToFile(%this.saveTo);
		}
		%this.disconnect();
		echo("Downloaded successfully.");
		MessageAll('', "\c6File downloaded in \c4" @ mCeil($Sim::Time - %this.startTime) @ "\c6 seconds.");
		serverDirectSaveFileLoad(%this.saveTo, 3, "", 1, 0);
		%this.schedule(500,delete);
	}
	
	function WebSavesDownloader::downloadFile(%this,%uni_code)
	{
		%saveTo = "base/server/WebSaves/temp.bls";
		
		if(%uni_code $= "")
		{
			return;
		}
		
		if(isFile(%saveTo))
		{
			fileDelete(%saveTo);
		}
		
		%this.server = "blocklandsaves.com";
		%this.port = 80;
		%this.dir = "/api.php?cmd=dl&f=" @ %uni_code;
		%this.saveTo = %saveTo;
		%this.fileName = fileName(%this.saveTo);
		%this.length = "";
		%this.connect(%this.server @ ":" @ %this.port);
	}
	
	function WebSaves_DownloadFile(%uni_code)
	{
		if(!isObject(WebSavesDownloader))
		{
			new TCPObject(WebSavesDownloader);
		}
		
		WebSavesDownloader.downloadFile(%uni_code);
	}
};
activatePackage("WebSavesServer");

function serverCmdWebSaves_DownloadFile(%this, %uni_code)
{
	if(!%this.isAdmin)
	{
		commandToClient(%this, 'WebSaves_ClientError', "401: Unauthorized", "You are not authorized to download saves.");
		return;
	}
	MessageAll('', "\c4" @ %this.name SPC "\c6loaded a save from the web.");
	WebSaves_DownloadFile(%uni_code);
}